## Formula Viewer
## v 1.0
## 2012 - May - 16
## 
## Author: A. Roslovtsev
## Email: andrei[AT]bytes-and-pixels[DOT]com
## Web: www.bytes-and-pixels.com
## 
## This tool is a helper for Vector Path plug-in for Gimp
## It allows to preview your curve interactively
## 
## This script is free software under GPL license.

import sys
from Tkinter import *
from math    import *

class fview():
    def __init__(self,Width=400, Height=400):
    
            # Event Handlers ---------------------------------
            
            def update(event):
                points = int(p_fld.get())
                xf = x_fld.get()
                yf = y_fld.get()
                
                self.process(xf,yf,points,canvas)


            # Create GUI window ------------------------------

            win = Tk()
            win.title ("Formula Viewer v1.0")
        
            x_lbl = Label(win,text="X:")
            x_lbl.grid(row=0)

            x_fld = Entry(win,width=100)
            x_fld.bind("<Return>",update)
            x_fld.insert(0,"(i*0.8)*10")
            x_fld.grid(row=0, column=1)

            y_lbl = Label(win,text="Y:")
            y_lbl.grid(row=1)
            
            y_fld = Entry(win,width=100)
            y_fld.insert(0,"200+(sin(i*0.2)*20)")
            y_fld.bind("<Return>",update)
            y_fld.grid(row=1, column=1)

            p_lbl = Label(win,text="Points:")
            p_lbl.grid(row=2)
            
            p_fld = Spinbox(win,width=10,from_=10, to=10000)
            p_fld.delete(0,END)
            p_fld.insert(0,100)
            p_fld.bind("<Return>",update)
            p_fld.grid(row=2,column=1,sticky=W)
            
            canvas = Canvas(win,width=Width,height=Height)
            canvas.create_line(0,Height/2,Width,Height/2)
            canvas.grid(row=3, columnspan=3)

            note_lbl = Label(win,text="Use this tool to create your curve's formulae (hit ENTER to refresh), then paste to the plugin dialog fields.")
            note_lbl.grid(row=4,columnspan=3)
            
            points = int(p_fld.get())
            xf = x_fld.get()
            yf = y_fld.get()

            self.data = [[0.0,0.0] for i in range(points)]
            self.points = points

            self.process(xf,yf,points,canvas)
            win.mainloop()
       
    def process (self,xf, yf,points,canvas,Width=400, Height=400):
        self.data = [[0.0,0.0] for i in range(points)]
        self.points = points
        for p in range(points):
            i = p
            phi = 1.61803399
            phi_inv = 0.6180340
            
            self.data[i][0]=eval(xf)
            self.data[i][1]=eval(yf)

##            try:
##                prev_x = self.data[i-1][0]
##            except:
##                prev_x = self.data[i][0]
            
            self.plotOne (canvas,Width,Height)



    def plotOne (self, canvas, Width, Height) :
            #items = canvas.find_all()
            canvas.delete(ALL)
            for i in range(len(self.data)) :
                x = self.data[i][0]
                y = self.data[i][1]
                if i : canvas.create_line(self.data[i-1][0],yprev,x,y)
                yprev = y
def run():
    inst = fview(640,480)

if __name__ == "__main__" : run()
